<?php
#!/usr/bin/php -q

//STANDARD SCRIPT SERVER HEADER!!!
$no_http_headers = true;

/* display No errors */
error_reporting(E_ERROR);

/* serverstats */
function decrypt($string){
    $decrypted = '';
    $key = 'Though this does the job, I cant guarantee that this is unbreakable'; // change this to some unique value.. should be same in both scripts
    $string = base64_decode($string);
    for( $i = 0; $i < strlen($string); $i++){
            $c = ord(substr($string, $i));
            $c -= ord(substr($key, (($i + 1) % strlen($key))));
            $decrypted .= chr(abs($c) & 0xFF);
    }
    return $decrypted;
}

function getBytes($mem){
   list($int, $lbl) = explode(' ', trim($mem));
   switch(strtolower($lbl)){
    case 'kb':
        $int = $int * 1024;
    break;
    case 'mb':
        $int = $int * 1024 * 1024;
    break;
   }
   
   return $int;
}

function get_netdev(){
  $data = @file('/proc/net/dev');
  $rx = 0;
  $tx = 0;
  /* skip the first two lines */
  for($i = 2; $i < count($data); $i++){
    list($dev, $infostr) = explode(':', $data[$i]);
    $c = explode(' ', trim(preg_replace("@\s+@",' ', $infostr)));
    $dev = trim($dev);
    if($dev == 'lo') continue;
    $rx += $c[0];
    $tx += $c[8];
  }
  printf("rx:%d tx:%d ", $rx, $tx);
}

function get_meminfo(){
  $mem_tags = array("memtotal","memfree", "buffers", "cached", "swaptotal", "swapfree");
  $d = @file('/proc/meminfo');
  $t = array();
  $f = array();
  foreach($d as $line){
    list($k, $v) = explode(':', trim($line));
    $k = strtolower($k);
    $v = getBytes($v);
    if(in_array($k, $mem_tags)){
        if(strpos($k, 'free') !== false) $f[$k] += $v * 1;
        if(strpos($k, 'total') !== false) $t[$k] += $v * 1;
        printf("%s:%d ", $k, $v);
    }
  }
  foreach($t as $k => $v){
    $k = str_replace('total','free', $k);
    $v = $v - $f[$k];
    $k = str_replace('free','used', $k);
    printf("%s:%d ", $k, $v);
  }

}

function get_loadavg(){
  $loadavg = explode(' ', file_get_contents('/proc/loadavg'));
  printf("la01:%01.2f ", $loadavg[0]);
  printf("la05:%01.2f ", $loadavg[1]);
  printf("la15:%01.2f ", $loadavg[2]);
}  
 
function get_cpuinfo(){  
  $def = array('user','nice','system','idle','iowait','irq','softirq');
  $infostr = @file('/proc/stat');
  $cpu_info = explode(' ', preg_replace("@\s+@",' ', trim($infostr[0])));
  $cpu = array();
  $total = 0;
  foreach($def as $i => $key){
    $cpu[$key] = $cpu_info[($i + 1)] * 1;
    $total += $cpu[$key];
  }
  foreach($def as $key){
    $p = ( $cpu[$key] / $total ) * 100;
    printf("%s:%01.2f ", $key, $p);
  }
}


function get_diskinfo($eol = ''){

  // refer: iostats.txt, linux kernel documentation
  $fields = array('CompletedReadCount', 'MergedReadCount', 'SectorsRead', 'ReadTimeMs','CompletedWriteCount', 'MergedWriteCount', 'SectorsWritten', 'WriteTimeMs', 'PendingIO', 'IOTimeMs', 'OverheadRatio');

  $data = file_get_contents("/proc/diskstats");
  $dd = array();
  exec("/bin/df -h | grep '^/dev' | grep -v 'cdrom'", $dd);
  $ss = join("\n", $dd);
  preg_match_all("@/dev/([a-z]+)@", $ss, $m);
  $disks = array_unique($m[1]);
  $diskinfo = array();

  preg_match_all("@\s(" . join('|', $disks) . ")\s([0-9 ]+)@", $data, $g);

  foreach($g[1] as $k => $val){
    $a = explode(' ', $g[2][$k]);
    $diskInfo = @array_combine($fields, $a);
    if($diskInfo !== false){
       $diskInfo['ReadSpeed'] = ($diskInfo['SectorsRead'] * 512 * 8) / ($diskInfo['ReadTimeMs'] / 1000);
       $diskInfo['WriteSpeed'] = ($diskInfo['SectorsWritten'] * 512 * 8) / ($diskInfo['WriteTimeMs'] / 1000);
       $info['disks'][$val] = $diskInfo;
    }
  }
  ksort($info['disks']);

  $data = array();
  exec('/bin/df -P -k', $data);
  foreach($data as $dfInfo){
     if(preg_match("@^(\/\S+|tmpfs)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)%\s+(\/\S*)$@",$dfInfo, $my) !== false){
       if(empty($my[1])) continue;
       if($my[1] == 'tmpfs' && $my[6] !== '/dev/shm') continue;
       elseif($my[1] == 'tmpfs' && $my[6] == '/dev/shm')
          $my[1] = '/dev/shm';
        $info['partitions'][$my[1]] = array(
        	'device' => $my[1],
			'mount' => $my[6],
			'total' => $my[2],
			'used' => $my[3],
			'available' => $my[4],
			'percent' => $my[5]);
     }
  }

  ksort($info['partitions']);

  echo base64_encode(gzcompress(serialize($info)));
}

function get_MysqlStatus(){
   #-- mostly this setup would  be used only by
   #-- standard localhost setups.. 
   $cfg = $_POST['cfg'];
   
   $conn = mysql_connect('localhost', 'root', '');
   if ( !$conn ) {
      die("MySQL: " . mysql_error());
   }
   
   $sql = decrypt($_POST['query']);
  
   $result = @mysql_query($sql, $conn);
   $array = array();
   while ( $row = @mysql_fetch_row($result) ) {
      $array[] = $row;
   }
   #-- the additional bit of computing
   echo base64_encode(gzcompress(serialize($array)));
}

function get_all($k = ''){
 ob_start();
   get_meminfo();
   echo $k;
   get_loadavg();
   echo $k;
   get_netdev();
   echo $k;
   get_cpuinfo();
   echo $k;
 $out = ob_get_clean();
   echo base64_encode(gzcompress($out));
}

function get_system(){
    get_meminfo();
    get_loadavg();
}

function get_debug(){
    get_all("\n");
}

if(!isset($_GET['o'])) $_GET['o'] = 'system';
if(isset($_POST['o'])) $_GET['o'] = $_POST['o'];
$fn = 'get_' . strtolower($_GET['o']);
if(function_exists($fn)) $fn();
    
flush();
exit();



